/* mna1d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer nreal;
} mna1rr_;

#define mna1rr_1 mna1rr_

/* Subroutine */ int mna1d_c(D_fp f, doublereal *a, doublereal *b,
        doublereal *c__, doublereal *fa, doublereal *fb, doublereal *fc,
        integer *iflag, integer *nmax)
{
    /* Initialized data */

    static doublereal gold = 1.618034;
    static doublereal glimit = 100.;
    static doublereal tiny = 1e-5;

    /* System generated locals */
    integer i__1;
    doublereal d__1, d__2, d__3, d__4;

    /* Builtin functions */
    double d_sign(doublereal *, doublereal *);

    /* Local variables */
    static doublereal ulim;
    static integer i__;
    static doublereal q, r__, u, fu, dum;

    *iflag = 0;
    *fa = (*f)(a);
    *fb = (*f)(b);
    if (*fb <= *fa) {
        goto L10;
    }
    dum = *a;
    *a = *b;
    *b = dum;
    dum = *fb;
    *fb = *fa;
    *fa = dum;
L10:
    *c__ = *b + gold * (*b - *a);
    *fc = (*f)(c__);
    i__1 = *nmax;
    for (i__ = 1; i__ <= i__1; ++i__) {
        mna1rr_1.nreal = i__;
        if (*fb < *fc) {
            goto L100;
        }
        r__ = (*b - *a) * (*fb - *fc);
        q = (*b - *c__) * (*fb - *fa);
/* Computing MAX */
        d__3 = (d__1 = q - r__, abs(d__1));
        d__2 = max(d__3,tiny);
        d__4 = q - r__;
        u = *b - ((*b - *c__) * q - (*b - *a) * r__) /
                 (d_sign(&d__2, &d__4) * 2.);
        ulim = *b + glimit * (*c__ - *b);
        if ((*b - u) * (u - *c__) <= 0.) {
            goto L40;
        }
        fu = (*f)(&u);
        if (fu >= *fc) {
            goto L20;
        }
        *a = *b;
        *fa = *fb;
        *b = u;
        *fb = fu;
        goto L80;
L20:
        if (fu <= *fb) {
            goto L30;
        }
        *c__ = u;
        *fc = fu;
        goto L80;
L30:
        u = *c__ + gold * (*c__ - *b);
        fu = (*f)(&u);
        goto L70;
L40:
        if ((*c__ - u) * (u - ulim) <= 0.) {
            goto L50;
        }
        fu = (*f)(&u);
        if (fu >= *fc) {
            goto L70;
        }
        *b = *c__;
        *c__ = u;
        u = *c__ + gold * (*c__ - *b);
        *fb = *fc;
        *fc = fu;
        fu = (*f)(&u);
        goto L70;
L50:
        if ((u - ulim) * (ulim - *c__) < 0.) {
            goto L60;
        }
        u = ulim;
        fu = (*f)(&u);
        goto L70;
L60:
        u = *c__ + gold * (*c__ - *b);
        fu = (*f)(&u);
L70:
        *a = *b;
        *b = *c__;
        *c__ = u;
        *fa = *fb;
        *fb = *fc;
        *fc = fu;
L80:
        ;
    }
    goto L90;
L100:
    *iflag = 1;
L90:
    return 0;
} /* mna1d_c */
